> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developers.awork.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developers.awork.com/_mcp/server.

# Returns all custom field definitions.

GET https://api.awork.com/api/v1/customfielddefinitions

Returns all custom field definitions in the workspace. Set `includeLinkedProjectIds` to include the projects linked to each definition.Any authenticated user.

Reference: https://developers.awork.com/apiv1/custom-fields/get-custom-field-definitions

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Query parameters

- `includeLinkedProjectIds` (boolean, optional, default: false) — Whether to include linked project Ids in the response.

## Response

### 200

OK

- `list of CustomFieldDefinitionWithSelectionOptionsAndLinkedProjectIds`

## Types

### CustomFieldDefinitionWithSelectionOptionsAndLinkedProjectIds

- `id` (string, optional) — The id of the custom field definition.
- `name` (string, optional, nullable) — The name of the custom field definition.
- `entity` (enum, optional) — The entity the custom field definition can be linked to.
  - Allowed values: `task`, `project`
- `type` (enum, optional) — The type of the custom field definition.
  - Allowed values: `text`, `number`, `date`, `datetime`, `select`, `coloredSelect`, `link`, `boolean`, `user`, `client`
- `createdOn` (string, optional) — The date this entity was created.
- `createdBy` (string, optional) — The id of the user who created this entity.
- `updatedOn` (string, optional) — The date this entity was last modified.
- `updatedBy` (string, optional) — The id of the user who last modified this entity.
- `order` (double, optional, nullable) — If it's a project custom field, it's the global order of the custom field definition. Otherwise, it's the order of the custom field definition within a project template or a project.
- `isExternal` (boolean, optional) — True if this entity is coming from an external workspace (awork Connect).
- `selectionOptions` (list of CustomFieldSelectionOption, optional, nullable) — The selection options for this custom field definition.
- `linkedProjectIds` (list of string, optional, nullable) — The linked project ids for this custom field definition.

### CustomFieldSelectionOption

- `value` (string, required) — The selection value which can be later used in a select custom field.
- `id` (string, optional) — The id of the custom field selection option.
- `color` (enum, optional, nullable) — The color of the selection option.
  - Allowed values: `red`, `orange`, `yellow`, `green`, `cyan`, `blue`, `indigo`, `purple`, `steel`
- `order` (double, optional) — The order of the custom field selection option.

## Examples

**Response**

```json
[
  {
    "id": "123e4567-e89b-12d3-a456-426614174000",
    "name": "Ticket-Number",
    "entity": "task",
    "type": "text",
    "createdOn": "2022-03-10T16:25:09.100Z",
    "createdBy": "123e4567-e89b-12d3-a456-426614174000",
    "updatedOn": "2022-03-10T18:55:00.500Z",
    "updatedBy": "123e4567-e89b-12d3-a456-426614174000",
    "order": 1,
    "isExternal": true,
    "selectionOptions": [
      {
        "value": "Website Design",
        "id": "123e4567-e89b-12d3-a456-426614174000",
        "color": "purple",
        "order": 0
      }
    ],
    "linkedProjectIds": [
      "123e4567-e89b-12d3-a456-426614174000"
    ]
  }
]
```

**SDK Code**

```python
import requests

url = "https://api.awork.com/api/v1/customfielddefinitions"

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.awork.com/api/v1/customfielddefinitions';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.awork.com/api/v1/customfielddefinitions"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.awork.com/api/v1/customfielddefinitions")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.awork.com/api/v1/customfielddefinitions")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.awork.com/api/v1/customfielddefinitions', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.awork.com/api/v1/customfielddefinitions");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.awork.com/api/v1/customfielddefinitions")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```